
import javax.media.opengl.GL;

/**
 *
 * @author Jeremy Smith
 */
public class CS752_Sphere 
{
    private final int space = 2;
    private final int vertexCount = (90/space)*(360/space)*4;
    private CS752_Vertex [] vertices = new CS752_Vertex[vertexCount];
    
    public void createSphere(float R, float H, float K, float Z)
    {
        int n = 0;
        for(float b = 0; b <= 90 - space; b += space)
        {
            for(float a = 0; a <= 360 - space; a += space)
            {
                vertices[n] = new CS752_Vertex();
                vertices[n].X = R * (float)Math.sin((a) / 180 * Math.PI) * (float)Math.sin((b) / 180 * Math.PI) - H;
                vertices[n].Y = R * (float)Math.cos((a) / 180 * Math.PI) * (float)Math.sin((b) / 180 * Math.PI) + K;
                vertices[n].Z = R * (float)Math.cos((b) / 180 * Math.PI) - Z;
                vertices[n].V = (2 * b) / 360;
                vertices[n].U = (a) / 360;
                n++;
                
                vertices[n] = new CS752_Vertex();
                vertices[n].X = R * (float)Math.sin((a) / 180 * Math.PI) * (float)Math.sin((b + space) / 180 * Math.PI) - H;
                vertices[n].Y = R * (float)Math.cos((a) / 180 * Math.PI) * (float)Math.sin((b + space) / 180 * Math.PI) + K;
                vertices[n].Z = R * (float)Math.cos((b + space) / 180 * Math.PI) - Z;
                vertices[n].V = (2 * (b + space)) / 360;
                vertices[n].U = (a) / 360;
                n++;
                
                vertices[n] = new CS752_Vertex();
                vertices[n].X = R * (float)Math.sin((a + space) / 180 * Math.PI) * (float)Math.sin((b) / 180 * Math.PI) - H;
                vertices[n].Y = R * (float)Math.cos((a + space) / 180 * Math.PI) * (float)Math.sin((b) / 180 * Math.PI) + K;
                vertices[n].Z = R * (float)Math.cos((b) / 180 * Math.PI) - Z;
                vertices[n].V = (2 * b) / 360;
                vertices[n].U = (a + space) / 360;
                n++;
                
                vertices[n] = new CS752_Vertex();
                vertices[n].X = R * (float)Math.sin((a + space) / 180 * Math.PI) * (float)Math.sin((b + space) /180 * Math.PI) - H;
                vertices[n].Y = R * (float)Math.cos((a + space) / 180 * Math.PI) * (float)Math.sin((b + space) /180 * Math.PI) + K;
                vertices[n].Z = R * (float)Math.cos((b + space) / 180 * Math.PI) - Z;
                vertices[n].V = (2 * (b + space)) / 360;
                vertices[n].U = (a + space) / 360;
                n++;
            }
        }
    }
    
    public void displaySphere(GL gl)
    {
        gl.glBegin(GL.GL_TRIANGLE_STRIP);
        
        for(int i=0; i<vertexCount; i++)
        {
            gl.glTexCoord2f(vertices[i].U, vertices[i].V);
            gl.glVertex3f(vertices[i].X, vertices[i].Y, -vertices[i].Z);
        }
        for(int i=vertexCount-1; i>=0; i--)
        {
            gl.glTexCoord2f(vertices[i].U, vertices[i].V);
            gl.glVertex3f(vertices[i].X, vertices[i].Y, vertices[i].Z);
        }
        
        gl.glEnd();
    }
}
